<div align="center" >🤝 Show your support - give a ⭐️ if you liked the content | <a target="_blank" href='https://twitter.com/intent/tweet?text=Cool%20js%20library&url=https%3A%2F%2Fgithub.com%2FPuliczek%2Fjsongpt-js'>SHARE on Twitter</a>
| Follow me on
 <a target="_blank" href='https://twitter.com/pulik_io'><img src='https://img.shields.io/badge/Twitter-%231DA1F2.svg?&style=flat&logo=twitter&logoColor=white'/></a>
 <a target="_blank" href='https://www.youtube.com/channel/UCaAdOBH2hnqLvEri1M7eg5Q'><img src='https://img.shields.io/badge/YouTube-%23FF0000.svg?&style=flat&logo=youtube&logoColor=white'/></a>
</div>

---

# JsonGPT-js 🔥🚀 from  <a target="_blank" href='https://JsonGPT.com/'>JsonGPT.com</a>
[![Bundle Size](https://badgen.net/bundlephobia/minzip/jsongpt-js)](https://bundlephobia.com/result?p=jsongpt-js)
[![npm downloads](https://img.shields.io/npm/dm/jsongpt-js.svg?style=flat-square)](http://npm-stat.com/charts.html?package=jsongpt-js)
[![](https://data.jsdelivr.com/v1/package/npm/jsongpt-js/badge)](https://www.jsdelivr.com/package/npm/jsongpt-js)
[![Tweet](https://img.shields.io/twitter/url/http/shields.io.svg?style=social)](https://twitter.com/intent/tweet?url=https%3A%2F%2Fgithub.com%2Fpuliczek%2Fjsongpt-js&via=pulik_io&text=Check%20out%20jsongpt&hashtags=js%2Cwebdev%2Coss)


**JsonGPT** is an intuitive **npm library** that enables software developers to efficiently integrate with **OpenAI functions**. Built with efficiency in mind, this library radically simplifies the process of filling information into any JSON data structures using OpenAI.

<p align="center">
  <img src="images/show.gif" alt="JsonGPT show"/>
</p>


# 📝 Features

- [x] **OpenAI Integration:** Smooth and effortless integration with OpenAI API and its functions.
- [x] **Automatic JSON streaming:** Striming of JSON data structures is automated using provided user descriptions.
- [x] **Fluent API Design:** A simple and streamlined interface tailored specifically for developers.
- [x] **Comprehensive Data Capture:** Capable of streaming in various JSON objects including strings, arrays, booleans, numbers, and nulls.
- [x] **Editable Prompts:** Users have the provision to customize default prompts as per their needs.
- [x] **BYOK OpenAIAPI Key:** Bring Your Own Key (BYOK). The API key for OpenAI can be easily edited. Defaults to fetching from environment variables if not provided.
- [x] **Flexible Control Parameters:** Temperature, top_p, n, presence_penalty, and frequency_penalty parameters are adjustable as per user needs.
- [x] **Strategic Data Handling:** Ability to stream JSON on both the client and the server side.
- [x] **Multi-Fill Capability (Client Side):** Multiple JSON streams can be executed on the client side.
- [ ] **Multi-Fill Capability (Server Side):** Multiple JSON streams on the server side is currently under development.
- [x] **JSON Parser:** Will only stream working JSONs.
- [ ] **Error Handler:** Error Handler is in progress for better exception management and easier debugging.
- [ ] **Detailed Analytics:** Analytics and insights regarding the usage and performance of the library, such as the most used functions, average computation time, etc. Panel on jsongpt.com.
- [ ] **Support for More Languages:** Usage in programming languages other than JavaScript/TypeScript.
- [ ] **Custom Data Sources:** Specify own data sources for populating JSON.
- [ ] **Integration with other AI platforms:** Expand compatibility beyond OpenAI to other AI platforms like Azure AI, etc.


# 📜 License Options

**JsonGPT** is completely **free** to use **for open source or personal projects**, licensed **under GPLv3**. However, to use JsonGPT in a **commercial project**, you need to purchase a **paid license**. Here are the available licenses:

- **Single Commercial License:** This license allows you to use **JsonGPT** in one commercial project. The project can be either your own or a client's project. [Purchase Here](https://www.jsongpt.com/single-commercial-license)

- **Extended Commercial License:** This license allows the use of **JsonGPT** in multiple commercial projects without any restriction. [Purchase Here](https://www.jsongpt.com/extended-commercial-license)

**Please note, the aim behind the paid licensing is to support the continued development and maintenance of the JsonGPT project.**

For more information on the licensing, please visit our [licensing page](https://www.jsongpt.com/licenses).


# 🤔 Are you using jsonGPT? Share your project

I'd love to see what are you building! 🤩 <a target="_blank" href="https://twitter.com/pulik_io">Tweet at me</a>

# 🤝 Show your support

<div>🤝 Show your support - give a ⭐️ if you liked the content | <a target="_blank" href='https://twitter.com/intent/tweet?url=https%3A%2F%2Fgithub.com%2FPuliczek%2Fawesome-list-of-secrets-in-environment-variables&via=pulik_io&text=Awesome%20list%20of%20secrets%20in%20environment%20variables'>SHARE on Twitter</a>
| Follow me on
 <a target="_blank" href='https://twitter.com/pulik_io'><img src='https://img.shields.io/badge/Twitter-%231DA1F2.svg?&style=flat&logo=twitter&logoColor=white'/></a>
 <a target="_blank" href='https://www.youtube.com/channel/UCaAdOBH2hnqLvEri1M7eg5Q'><img src='https://img.shields.io/badge/YouTube-%23FF0000.svg?&style=flat&logo=youtube&logoColor=white'/></a>
</div>