import { describe, it } from "vitest";
import JsonGPT from "./jsonGPT";

type personType = {
  name: string;
  age?: number;
};

interface Iperson {
  name: string;
  age?: number;
}

const personObject = {
  name: "asd",
  age: 2,
};

describe("jsonGPT intellisense tests", () => {
  it("JsonGPT type", () => {
    const jsonGPT = new JsonGPT();
    jsonGPT.schema<personType>({ name: "it is user name", age: "this is age" });
  });

  it("JsonGPT interface", () => {
    const jsonGPT = new JsonGPT();
    jsonGPT.schema<Iperson>({ name: "it is user name", age: "this is age" });
  });

  it("JsonGPT object", () => {
    const jsonGPT = new JsonGPT();
    jsonGPT.schema<typeof personObject>({ name: "it is user name", age: "this is age" });
  });

  it("JsonGPT null", () => {
    const jsonGPT = new JsonGPT();
    jsonGPT.schema({ name: "it is user name", age: "it is user age" });
  });
});

// describe("jsonGPT prompts tests", () => {
//   const backlinks = {
//     domains: [],
//   };

//   it("JsonGPT simple", async () => {
//     await new JsonGPT()
//       .openAIApiKey(process.env.OPENAI_API_KEY)
//       .startingObject(backlinks)
//       .system("You are a SEO profesionalist.")
//       .prompt(
//         "Add 4 domain where I can get a backlink to my website (JsonGPT.com), they should be a REAL websites where i can create an account and add my domain. DO not use fake backlinks like 'example.com'. Backlink should be high domain authority and related to topic of the application. Desctiption for my website 'It is a npm library to help software developers to integrate easily with OpenAI functions. The startup name is JsonGPT, and the domain is jsongpt.com. It is bootstrapped and built only by me. What problem is my SaaS solving? It speeds up and is easier to integrate with openAI functions. The main feature is that user can have some object or array, and jsonGPT by using openAI will fill data based on the description of the user.'"
//       )
//       .temperature(0.7)
//       .topP(1)
//       .schema<typeof backlinks>({
//         domains: "Real websites domains for my website to get backlinks",
//       })
//       .stream()
//       .then((x) => {
//         console.log(x.lastTarget);
//       });
//   });
// });

// describe("jsonGPT prompts tests", () => {
//   const startup = {
//     name: "TikTokerkaAI",
//     description: "Service adds subtitles to every tik tok video",
//     productType: "",
//     customers: [],
//     domainName: "",
//     mission: "",
//     vision: "",
//     solveProblems: [],
//     techStack: [],
//     exitStrategy: "",
//     features: [
//       {
//         name: "",
//         businessLogic: "",
//         howToDevelop: "",
//       },
//     ],
//     landingPage: {
//       header: "",
//       tagline: "",
//       description: "",
//       callToAction: "",
//       testimonials: [
//         {
//           name: "",
//           comment: "",
//         },
//       ],
//     },
//     marketing: {
//       reddit: [],
//       keywords: [],
//     },
//     faq: [
//       {
//         question: "",
//         answer: "",
//       },
//     ],
//     brandIdentity: {
//       brandColors: [],
//       brandFonts: [],
//     },
//   };

//   it("JsonGPT advence", async () => {
//     await new JsonGPT()
//       .openAIApiKey(process.env.OPENAI_API_KEY)
//       .startingObject(startup)
//       .system("You are an CEO, you know how to build great saas applications.")
//       .prompt("Give me an idea for new startup for Tiktokers, startup should be using AI")
//       .schema<typeof startup>({
//         name: "name of the startup",
//         description: "max to 100 words",
//         productType: "example: website, mobile app, chrome extension",
//         customers: "who can buy it",
//         domainName: "it should ends with .io ex. saas.io",
//         mission: "what the mission for the startup",
//         vision: "write me a vision for it",
//         solveProblems: "three problems that it solves",
//         techStack: "write an example techstack",
//         exitStrategy: "write possible story of exit strategy it shoud have at least 500 words",
//         features: {
//           description: "write 5 features of product",
//           items: {
//             name: "the name of the feature",
//             businessLogic: "write a business logic of feature",
//             howToDevelop: "Write a prompt for a chatgpt to create the feature",
//           },
//         },
//         landingPage: {
//           description: "description on the landing page",
//           header: "main text on landing page, it should have aha moment that user will get what startup is about",
//           tagline: "secondary text about startup",
//           callToAction: "write good selling call to action",
//           testimonials: {
//             description: "minimum 5, must be related with a startup topic",
//             items: {
//               name: "customer name",
//               comment: "text must have at least 50 words and 3 emoji",
//             },
//           },
//         },
//         marketing: {
//           reddit: "List of subreddits URLs where I can find customers, minimum 3, ex. 'reddit.com/r/hackers/'",
//           keywords: "keywords for SEO that can bring my clients, minimum 3",
//         },
//         brandIdentity: {
//           brandColors: "in hex, example: #000fff",
//           brandFonts: "write what font is good for it",
//         },
//         faq: {
//           description: "list of questions and answers that can be most common asked by users, minimum 5",
//           items: {
//             question: "write a question",
//             answer: "Write an answer to the question, must include one emoji",
//           },
//         },
//       })
//       .stream()
//       .then((x) => {
//         console.log(x.lastTarget);
//       });
//   });
// });
